︠16098c6f-7abe-4f9f-896b-cbeb3696d1c3︠
# GAMBLER'S RUIN SIMULATION

# We start with a stake of a certain number of dollars, 
# and then play a betting game where we win or lose a unit of money.  
# Each time we play, the probability of winning is fixed.
# We will draw a graph of our financial position 
# (imagine we bet once a day, then the x-axis of the graph is days, 
# and the y-axis is the amount of money we have).

start= 100          # start with 100 dollars
nBets = 100         # we will bet 100 times
betSize = 1         # each bet is for 1 dollar
pWin = 0.48         # we win each bet with probability 45%
wealth = start      # this variable holds our total accumulation.
daily =[wealth]     # this initializes an array (list), whose first (0th) member is the value of
                    # wealth.  Eventually the array will have nBets items, the amount accumulated 
                    # each day.

# The next line is a looping command.  The "_" is just a dummy index variable; it can be given
# any name.  So the loop means "repeat as many times as the variable nBets."
# Notice that after the loop command, there is a colon (":") and then the code automatically 
# indents.  This is how the if and else commands work, as well.
for _ in range(nBets):    
    if random()<pWin:        # if command; it will be true with probability pWin
        wealth += betSize    # if true, we increment wealth by the betSize value
    else:                    # otherwise (note the colon and automatic indent)
        wealth -= betSize    # we decrease wealth by the betSize value
    daily.append(wealth)     # the last line of the loop is to append the current wealth value
                             # to the variable daily  (which is a list)
    
# The final lines create a variable for the plot, print out some values, and then display the plot.
l=list_plot(daily,plotjoined=True)
print('P(win) = %.3g'%pWin)
print('Start value: %s' %start)
print('End value: %s' %daily[nBets])
show(l)
︡b182227b-ff7a-4616-81bd-4c4045073b64︡{"stdout": "P(win) = 0.48\nStart value: 100\nEnd value: 92"}︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠2b824c8c-4375-4b6b-b96e-8b36cfea0279︠
#interactive version  (the hashtag precedes comments which SAGE doesn't interpret)


@interact
def _(pWin=slider(0,1,.01,default=0.48,display_value=False), betSize = [1,10,100], nBets =(100,[1,10,100,1000,5000]),fixedAxis=checkbox(False,"Fixed Axis")):
    start= 100
    wealth = start
    daily =[wealth]
    for _ in range(nBets):
        if random()<pWin:
            wealth += betSize
        else:
            wealth -= betSize
        daily.append(wealth)
        
    l=list_plot(daily,plotjoined=True)
    if fixedAxis:
        l.set_axes_range(0,nBets,-1.5*start,1.5*start)
    print('P(win) = %.3g'%pWin)
    print('Start value: %s' %start)
    print('End value: %s' %daily[nBets])
    show(l)
︡dce2f464-038c-48ec-a127-15312366d6c5︡︡
︠0b252768-b61b-4afb-a348-a394de957f79︠
r=.52/.48
︡620397b5-40fd-4622-8c95-c468e9a58e00︡︡
︠409c7026-c4c9-49a6-b501-bec00f729bd2︠
1/(r^10+1)
︡88c91070-3006-401e-aaea-45b8de6fe6a4︡{"stdout": "0.309934170430358"}︡
︠247c32b0-42fc-4092-93eb-0f190a336de5︠
1/(r^100+1)
︡638cdca6-4c70-4f66-90f0-2e05e0dff5e8︡{"stdout": "0.000333921459253053"}︡
